MantisBT
Mantis Bug Tracker Workflow

View Issue Details Jump to Notes ] Related Changesets ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0025231Open CASCADE[OCCT] OCCT:DRAWpublic2014-09-10 15:272014-11-11 13:01
Reporterabv 
Assigned Tobugmaster 
PrioritynormalSeverityminor 
StatusclosedResolutionfixed 
PlatformOSOS Version
Product Version[OCCT] 6.8.0 
Target Version[OCCT] 6.8.0Fixed in Version[OCCT] 6.8.0 
Summary0025231: DRAW - make top level menu useful
DescriptionWhen DRAW starts, it shows separate window with menu bar, containing three menus: File, Views, and Display. Some additional menus are added when DRAW plugins are loaded (e.g. after "pload ALL"). In theory these menus should provide convenient means for the new users to start using DRAW. However, the implementation is extremely poor and these menus are mostly unusable and / or useless.

This issue is a proposal to improve some aspects of this:

- Menu items currently contain just names of DRAW commands. It would be better to provide meaningful texts, with names of corresponding DRAW commands in parentheses. E.g., instead of "restore" it would be better to have "Load Shape (restore)".

- 'Open File' dialog shown when user selects commands File/datadir, File/restore, File/source is extremely poor; standard dialog (Tcl command tk_getOpenFile) should be used instead

- Add menu 'Help', with three items:
  - 'User Guide', providing short-cut to DRAW UG (if found)
  - 'Commands', providing access to information accessible via command 'help'. This item can open a kind of browser dialog listing all commands (or categories, then commands), each item providing a short-cut to help on corresponding command
  - 'About', showing OCC logo, copyright statement, and link to OCC web sites

- Add menu 'Samples', which would allow running samples located in samples/tcl. It would be nice to have this menu populated automatically by available scripts; some easy way to organize this sub-menu by some special mark-up text in the test case comment can be used.

As a further extension, an option can be provided to start DRAW as application with one main window, so that text log and viewer windows be its children. This would make DRAW looking more like conventional application.
Additional information
and documentation updates
See src/DrawResources/DrawTK.tcl for current code
TagsNo tags attached.
Test case number
Attached Filesdoc file icon New draw menu.doc (1,218,560 bytes) 2014-09-23 15:19

- Relationships
parent of 0025359closedbugmaster In Draw Test Harness: content of menu-items "Curves" and "Surfaces" is increased after each sample launching 

-  Notes
(0032008)
isz (developer)
2014-09-23 15:21

Dear Andrey,
Could you please take a look on the new draw menu design (attached file).
Samples menu is not ready yet, but in the attached document there are some options for its design. Please select the best one.

Thank you!
(0032025)
abv (manager)
2014-09-23 16:42

Looks nice, please proceed.

A few remarks from my side:

- File menu: please add a space before (restore) and (save)

- About dialog: please keep only www.opencascade.org, and make it centered

- Error message if no User Guide: wording "Please generate documentation with WOK" is not really correct as WOK is not a tool to generate docs any more. Perhaps instead of putting such error message we can open HTML variant: either local (doc/overview/html/occt_user_guides__test_harness.html), if present, or on-line (http://dev.opencascade.org/doc/overview/html/occt_user_guides__test_harness.html [^])

Regarding Samples sub-menu, my idea was to populate menu automatically by a list of available samples. The description could be shown as tool-tip when you hover a mouse over the menu item for some time (if Tk supports that, of course).

However I like the idea (as I understood it) of displaying text of the sample in separate dialog where the user can review it before (or in parallel to) executing. Not sure this will be appreciated in all cases, but anyway, let's try this and see how it works...

Please share your development via branch as soon as you reach some stable status
(0032100)
git (administrator)
2014-09-24 17:24

Branch CR25231 has been created by isz.

SHA-1: b48b79d528f11e5bb2406ba8e4b6213a4b90f14e


Detailed log of new commits:

Author: isz
Date: Wed Sep 24 17:24:42 2014 +0400

    0025231: DRAW - make top level menu useful
    
    -In menu meaningful texts are provided instead of commands (e.g. restore->Load Shape (restore))
    -tk_getOpenFile is used in "open file" dialogs
    -tk_chooseDirectory is used in "change directory" dialog
    -Added menu "Help" with submenus "Commands", "About", "User Guide"
    -Added menu "Samples" with submenu "View samples"
(0032101)
isz (developer)
2014-09-24 17:27

Dear Andrey,
Please take a look on branch CR25231.
Could you please provide titles and categories for samples in /samples/tcl?

Thank you!
(0032103)
abv (manager)
2014-09-24 18:57

Some remarks:
- When I click File -> Load Shape and then exit dialog by Cancel, error messages appear in command prompt
- Please capitalize first letter in "exit" in File menu
- Please try to make menu 'Help' always last. Now when new submenus are added (e.g. after pload ALL), they appear after Help
- About dialog is poor; please make it greater (adding more space), add button "Close" (or "OK"), and let it appear at the center of the screen. Make it modal.
- It may be worth displaying system information in About dialog (commands dversion, meminfo, vglinfo if VISUALIZATION is loaded), or add a separate menu item for that
- Exclude files with extensions other than .tcl from the list of samples (you have listed Readme.txt as sample)
- Before starting sample, try to clean up DRAW environment (use command dall to remove all DRAW variables, vclear to clean viewers, vclose to close viewers etc.)
- When starting sample, please switch focus to command window, or suppress sample dialog otherwise, to ensure that the user sees how the sample is executed, and viewer windows it creates
- In Help browser, it would be very nice to have some search functionality
(0032104)
abv (manager)
2014-09-24 19:04

Samples and categories:

Demos:
  Modeling operations (ModelingDemo.tcl)
  Displaying 3d viewer (VisualizationDemo.tcl)
  Import and export (DataExchangeDemo.tcl)
Modeling:
  OCCT Tutorial bottle shape (bottle.tcl)
  CAD shape (cad.tcl)
  Drill (drill.tcl)
  Milling cutter (cutter.tcl)
Visualization:
  Material properties in viewer (materials.tcl)
  Ray tracing (raytrace.tcl)
  Display of complex scene and animation (spheres.tcl)
Application Framework:
  Work with assemblies, colors etc. in XDE (xde.tcl)
(0032574)
git (administrator)
2014-10-02 14:09

Branch CR25231 has been updated forcibly by isz.

SHA-1: 81fd3f034435b6f61856bda66e57082eceb0973f
(0032576)
isz (developer)
2014-10-02 14:10

-Fixed all remarks
-Two types of search added in "Commands" window:
  1)search through text of helpstrings
  2)command search
-Added submenu "System Info" in "Help" creating window with system informat
(0032577)
isz (developer)
2014-10-02 14:11

Dear Andrey,
Please take a look on branch CR25231.

Thank you!
(0032582)
abv (manager)
2014-10-02 14:54

Please improve a bit:
- add comments to procedures defined in DrawTK.tcl
- in System Info dialog, add button Close at the bottom
- add new menu "Load" allowing to call pload command for OCCT modules, with items found in 1st column in the file src/DrawResources/DrawPlugin
  
(0032606)
git (administrator)
2014-10-02 18:00

Branch CR25231 has been updated by isz.

SHA-1: 8ff3c581ba6fc54883c813f8827d470884366c9c


Detailed log of new commits:

Author: isz
Date: Thu Oct 2 17:59:58 2014 +0400

    -Added "Load" menu
    -Added comments to procedures
    -Added "Close" button on "System information" window

(0032717)
git (administrator)
2014-10-06 16:33

Branch CR25231 has been updated forcibly by isz.

SHA-1: 43299cb2f638ec1546685f491781e108dba45f31
(0032720)
git (administrator)
2014-10-06 16:56

Branch CR25231 has been updated forcibly by isz.

SHA-1: 36651a01671ad2f8f7cb2f6db07142f388502fcd
(0032739)
abv (manager)
2014-10-06 19:31

Reviewed, please test together with 0024802 (note that only interactive Tcl scripts changed, thus compilation and non-regression testings are not needed)
(0033436)
git (administrator)
2014-10-21 16:43

Branch CR25231 has been deleted by inv.

SHA-1: 36651a01671ad2f8f7cb2f6db07142f388502fcd

- Related Changesets
occt: master ab91ab6f
Timestamp: 2014-10-06 12:56:21
Author: isz
Committer: bugmaster
Details ] Diff ]
0025231: DRAW - make top level menu useful

-Meaningful texts are provided instead of commands in File menu (e.g. restore->Load Shape (restore))
-tk_getOpenFile is used in "open file" dialogs
-tk_chooseDirectory is used in "change directory" dialog
-Added menu "Help" with submenus "System info", "Commands", "About", "User Guide"
-Added menu "Samples" with submenu "View samples"
-Added menu "Load" with submenus "pload <Module>"
mod - samples/tcl/bottle.tcl Diff ] File ]
mod - samples/tcl/cad.tcl Diff ] File ]
mod - samples/tcl/cutter.tcl Diff ] File ]
mod - samples/tcl/DataExchangeDemo.tcl Diff ] File ]
mod - samples/tcl/drill.tcl Diff ] File ]
mod - samples/tcl/materials.tcl Diff ] File ]
mod - samples/tcl/ModelingDemo.tcl Diff ] File ]
mod - samples/tcl/raytrace.tcl Diff ] File ]
mod - samples/tcl/spheres.tcl Diff ] File ]
mod - samples/tcl/VisualizationDemo.tcl Diff ] File ]
mod - samples/tcl/xde.tcl Diff ] File ]
mod - src/DrawResources/CURVES.tcl Diff ] File ]
mod - src/DrawResources/DrawTK.tcl Diff ] File ]
add - src/DrawResources/OCC_logo.png Diff ] File ]
mod - src/DrawResources/SURFACES.tcl Diff ] File ]

- Issue History
Date Modified Username Field Change
2014-09-10 15:27 abv New Issue
2014-09-10 15:27 abv Assigned To => mkv
2014-09-15 17:34 abv Assigned To mkv => isz
2014-09-15 17:34 abv Status new => assigned
2014-09-23 15:18 isz File Added: New draw menu.tar.gz
2014-09-23 15:19 isz File Added: New draw menu.doc
2014-09-23 15:19 isz File Deleted: New draw menu.tar.gz
2014-09-23 15:21 isz Note Added: 0032008
2014-09-23 15:21 isz Assigned To isz => abv
2014-09-23 15:21 isz Status assigned => feedback
2014-09-23 16:42 abv Note Added: 0032025
2014-09-23 16:42 abv Assigned To abv => isz
2014-09-23 16:42 abv Status feedback => assigned
2014-09-24 17:24 git Note Added: 0032100
2014-09-24 17:27 isz Note Added: 0032101
2014-09-24 17:27 isz Assigned To isz => abv
2014-09-24 17:27 isz Status assigned => feedback
2014-09-24 18:57 abv Note Added: 0032103
2014-09-24 19:04 abv Note Added: 0032104
2014-09-24 19:14 abv Assigned To abv => isz
2014-09-26 06:46 abv Status feedback => assigned
2014-10-02 14:09 git Note Added: 0032574
2014-10-02 14:10 isz Note Added: 0032576
2014-10-02 14:11 isz Note Added: 0032577
2014-10-02 14:11 isz Assigned To isz => abv
2014-10-02 14:11 isz Status assigned => feedback
2014-10-02 14:15 isz Status feedback => resolved
2014-10-02 14:54 abv Note Added: 0032582
2014-10-02 14:54 abv Assigned To abv => isz
2014-10-02 14:54 abv Status resolved => assigned
2014-10-02 18:00 git Note Added: 0032606
2014-10-02 18:00 isz Assigned To isz => abv
2014-10-02 18:00 isz Status assigned => resolved
2014-10-06 16:33 git Note Added: 0032717
2014-10-06 16:56 git Note Added: 0032720
2014-10-06 19:31 abv Note Added: 0032739
2014-10-06 19:31 abv Assigned To abv => bugmaster
2014-10-06 19:31 abv Status resolved => reviewed
2014-10-06 20:58 mkv Assigned To bugmaster => mkv
2014-10-13 14:30 apv Relationship added parent of 0025359
2014-10-13 17:52 bugmaster Changeset attached => occt master ab91ab6f
2014-10-13 17:52 bugmaster Assigned To mkv => bugmaster
2014-10-13 17:52 bugmaster Status reviewed => verified
2014-10-13 17:52 bugmaster Resolution open => fixed
2014-10-21 16:43 git Note Added: 0033436
2014-11-11 12:43 aiv Fixed in Version => 6.8.0
2014-11-11 13:01 aiv Status verified => closed


Copyright © 2000 - 2020 MantisBT Team
Powered by Mantis Bugtracker